import Table from './packages/table/index.js';
// import ColumnSetting from './packages/column-setting/index';
import TableSearch from './packages/search/index';
import TableTool from './packages/table-tool/index';
import ToolItem from './packages/tool-item/index';
import CustomFilter from './packages/table-filter/index';
import Tree from './packages/tree/index';
import Editor from './packages/editor/index';
import '@riophae/vue-treeselect/dist/vue-treeselect.css'
import Treeselect from '@riophae/vue-treeselect'
// import TreeTable from 'tree-table-vue'
import xyForm from './packages/form-create/index';
import formCreate from 'f-create'

const components = [
  Table,
  Tree,
  TableSearch,
  TableTool,
  ToolItem,
  CustomFilter,
  Editor,
  xyForm
];

const install = function (Vue, opts = {}) {
  if (install.installed) return;
  Vue.use(formCreate);
  components.forEach(component => {
    Vue.component(component.name, component);
  });
  Vue.component('treeselect', Treeselect)
};

/* istanbul ignore if */
if (typeof window !== 'undefined' && window.Vue) {
  install(window.Vue);
}

module.exports.default = module.exports = {
  install,
  Table,
  Tree,
  TableSearch,
  TableTool,
  ToolItem,
  CustomFilter,
  Editor,
  xyForm
};

